<?php
if ( ! defined( 'ABSPATH' ) ) {
  exit; // Exit if accessed directly
}
global $current_user,$wpdb,$wppmfunction;
$task_per_page = 20;
$page_no = isset($_POST['page_no']) ? intval(sanitize_text_field($_POST['page_no'])): '0';
$search_tag = isset($_POST['task_search']) ? sanitize_text_field($_POST['task_search']) : '';
if(!empty($search_tag)){
  $search_tag_text = '%'.$search_tag.'%';
  if($current_user->has_cap('manage_options')){
    $query = ("SELECT Task.*
              FROM {$wpdb->prefix}wppm_task AS Task
              Left join {$wpdb->prefix}wppm_project proj ON Task.project = proj.id
              Left join {$wpdb->prefix}wppm_task_statuses task_statuses ON Task.status = task_statuses.id
              Left join {$wpdb->prefix}wppm_task_priorities task_priorities ON Task.priority = task_priorities.id
              Left join {$wpdb->base_prefix}users user ON (FIND_IN_SET(user.id,Task.users)>0) AND user.display_name LIKE '$search_tag_text'
              where Task.task_name LIKE '$search_tag_text' OR proj.project_name LIKE '$search_tag_text' OR task_statuses.name LIKE '$search_tag_text' OR task_priorities.name LIKE '$search_tag_text' OR user.display_name LIKE '$search_tag_text' Group by Task.id");
    $no_of_rows = ("SELECT count(*) FROM 
              (SELECT Task.*
              FROM {$wpdb->prefix}wppm_task AS Task
              Left join {$wpdb->prefix}wppm_project proj ON Task.project = proj.id
              Left join {$wpdb->prefix}wppm_task_statuses task_statuses ON Task.status = task_statuses.id
              Left join {$wpdb->prefix}wppm_task_priorities task_priorities ON Task.priority = task_priorities.id
              Left join {$wpdb->base_prefix}users user ON (FIND_IN_SET(user.id,Task.users)>0) AND user.display_name LIKE '$search_tag_text'
              where Task.task_name LIKE '$search_tag_text' OR proj.project_name LIKE '$search_tag_text' OR task_statuses.name LIKE '$search_tag_text' OR task_priorities.name LIKE '$search_tag_text' OR user.display_name LIKE '$search_tag_text' Group by Task.id) AS Task");
  }else{
    $query = ("SELECT Task.*
              FROM {$wpdb->prefix}wppm_task AS Task
              Left join {$wpdb->prefix}wppm_project proj ON Task.project = proj.id
              Left join {$wpdb->prefix}wppm_task_statuses task_statuses ON Task.status = task_statuses.id
              Left join {$wpdb->prefix}wppm_task_priorities task_priorities ON Task.priority = task_priorities.id
              Left join {$wpdb->prefix}wppm_project_users proj_users ON Task.project = proj_users.proj_id
              Left join {$wpdb->base_prefix}users user ON (FIND_IN_SET(user.id,Task.users)>0) AND user.display_name LIKE '$search_tag_text'
              where ((FIND_IN_SET('$current_user->ID',Task.users)>0) OR (Task.created_by= '$current_user->ID') OR (proj_users.user_id = '$current_user->ID' AND proj_users.role_id = 1 )) AND (Task.task_name LIKE '$search_tag_text' OR proj.project_name LIKE '$search_tag_text' OR task_statuses.name LIKE '$search_tag_text' OR task_priorities.name LIKE '$search_tag_text' OR user.display_name LIKE '$search_tag_text') Group by Task.id");
    $no_of_rows = ("SELECT count(*) FROM 
              (SELECT Task.*
              FROM {$wpdb->prefix}wppm_task AS Task
              Left join {$wpdb->prefix}wppm_project proj ON Task.project = proj.id
              Left join {$wpdb->prefix}wppm_task_statuses task_statuses ON Task.status = task_statuses.id
              Left join {$wpdb->prefix}wppm_task_priorities task_priorities ON Task.priority = task_priorities.id
              Left join {$wpdb->prefix}wppm_project_users proj_users ON Task.project = proj_users.proj_id
              Left join {$wpdb->base_prefix}users user ON (FIND_IN_SET(user.id,Task.users)>0) AND user.display_name LIKE '$search_tag_text'
              where ((FIND_IN_SET('$current_user->ID',Task.users)>0) OR (Task.created_by= '$current_user->ID') OR (proj_users.user_id = '$current_user->ID' AND proj_users.role_id = 1 )) AND (Task.task_name LIKE '$search_tag_text' OR proj.project_name LIKE '$search_tag_text' OR task_statuses.name LIKE '$search_tag_text' OR task_priorities.name LIKE '$search_tag_text' OR user.display_name LIKE '$search_tag_text') Group by Task.id) AS Task");
  }
}else{ 
  if($current_user->has_cap('manage_options')){
    $query = ( "SELECT * FROM {$wpdb->prefix}wppm_task");
    $no_of_rows = ( "SELECT count(*) FROM {$wpdb->prefix}wppm_task" );
  }else{
    $query = ( "SELECT Task.*
      FROM {$wpdb->prefix}wppm_task AS Task
      Left join {$wpdb->prefix}wppm_project proj ON Task.project = proj.id
      Left join {$wpdb->prefix}wppm_project_users proj_users ON Task.project = proj_users.proj_id
      where (FIND_IN_SET('$current_user->ID',Task.users)>0) OR (Task.created_by= '$current_user->ID') OR (proj_users.user_id = '$current_user->ID' AND proj_users.role_id = 1 ) Group by Task.id");
    $no_of_rows = ( "SELECT count(*) FROM
    ( SELECT Task.*
      FROM {$wpdb->prefix}wppm_task AS Task
      Left join {$wpdb->prefix}wppm_project proj ON Task.project = proj.id
      Left join {$wpdb->prefix}wppm_project_users proj_users ON Task.project = proj_users.proj_id
      where (FIND_IN_SET('$current_user->ID',Task.users)>0) OR (Task.created_by = '$current_user->ID') OR (proj_users.user_id = '$current_user->ID' AND proj_users.role_id = 1 )Group by Task.id) AS Task");
  }
}
$no_of_rows = apply_filters('wppm_task_list_no_of_rows',$no_of_rows);
$query = apply_filters('wppm_task_list_query',$query);
$totalrows = $wpdb->get_var($no_of_rows);
$limit_start=$page_no*$task_per_page;
$limit="\n LIMIT ".$limit_start.",".$task_per_page." ";
$task_id_array = array();
$query = $query.$limit;
$wppm_task_fillter = $wpdb->get_results($query);
?>
<div id="wppm_task_list_container">
  <div class="row">
    <div class="col-sm-6">
      <span class="wppm-heading-inline"> <?php echo esc_html_e('Tasks','taskbuilder');?> </span>
      <span class="wppm-add-new-btn btn-primary" onclick="wppm_add_new_task()"><img class="wppm_add_new_task_img" src="<?php echo esc_url( WPPM_PLUGIN_URL . 'asset/images/plus_icon.svg'); ?>" alt="add_icon"><?php echo esc_html_e('Add New','taskbuilder');?></span>
    </div>
    <div id="wppm_task_search" class="col-sm-6">
      <input type="search" id="wppm_task_search_filter" name="wppm_task_search_filter" class="form-control form-control-sm" aria-controls="selection-datatable" placeholder="<?php echo esc_attr__('Search','taskbuilder');?>" value="<?php echo (!empty($search_tag)) ? esc_attr($search_tag) : "" ?>">
      <img width="25" height="15" class="wppm_task_search_filter_img" src="<?php echo esc_url( WPPM_PLUGIN_URL . 'asset/images/search.svg'); ?>" alt="search">
    </div>
  </div>
  <div class="row">
    <div class="col-sm-12">
      <span id="wppm_grid_view_btn" onclick="wppm_view_task_search_filter(<?php echo esc_attr($page_no)?>)"><img src="<?php echo esc_url( WPPM_PLUGIN_URL . 'asset/images/grid_view.svg'); ?>" alt="grid_view"><span><?php echo esc_html_e('Grid view','taskbuilder');?></span></span>
    </div>
  </div>
  <div id="wppm_task_table_container" class="wppm_task_table_container table-responsive">
    <table id="wppm_task_table" class="wppm_table table">
      <thead>
        <tr>
          <th class="wppm_table_header">
            <?php echo esc_html_e('Task name','taskbuilder'); ?>
          </th>
          <th class="wppm_table_header">
            <?php echo esc_html_e('Project','taskbuilder'); ?>
          </th>
          <th class="wppm_table_header">
            <?php echo esc_html_e('Status','taskbuilder'); ?>
          </th>
          <th class="wppm_table_header">
            <?php echo esc_html_e('Priority','taskbuilder'); ?>
          </th>
          <th class="wppm_table_header">
            <?php echo esc_html_e('Start date','taskbuilder'); ?>
          </th>
          <th class="wppm_table_header">
            <?php echo esc_html_e('End date','taskbuilder'); ?>
          </th>
          <th class="wppm_table_header">
            <?php echo esc_html_e('Assign To','taskbuilder'); ?>
          </th>
          <th class="wppm_table_header">
            <?php echo esc_html_e('Progress','taskbuilder'); ?>
          </th>
        </tr>
      </thead>
      <tbody>
        <?php 
        $task_index = 0;
        if(!empty($wppm_task_fillter)){
          foreach($wppm_task_fillter as $task) {
              $checklists = $wpdb->get_results( "SELECT * FROM {$wpdb->prefix}wppm_checklist where task_id = $task->id" );
              if(!empty($task)){
                $task_index++;
                $total=$wpdb->get_var("SELECT COUNT(Items.id) AS check_id
                  FROM {$wpdb->prefix}wppm_checklist_items AS Items
                  Left join {$wpdb->prefix}wppm_checklist checklist ON Items.checklist_id = checklist.id
                  WHERE checklist.task_id = $task->id");
                $total_checked_items=$wpdb->get_var("SELECT COUNT(Items.id) AS check_id
                  FROM {$wpdb->prefix}wppm_checklist_items AS Items
                  Left join {$wpdb->prefix}wppm_checklist checklist ON Items.checklist_id = checklist.id
                  WHERE checklist.task_id = $task->id AND Items.checked=1");
                
                if(isset($task->status)){
                  $status = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}wppm_task_statuses where id = $task->status" );
                }
                if(!empty($task->priority)){
                  $priority = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}wppm_task_priorities where id = $task->priority" );
                }
                if(isset($task->project)){
                  $project = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}wppm_project where id = $task->project" );
                }
                ?>
                <tr onclick= "if(link)wppm_open_task(<?php echo esc_attr($task->id) ?>)" >
                  <td>
                    <?php echo esc_html_e($task->task_name,'taskbuilder') ?>
                  </td>
                  <td>
                    <?php if(!empty($project->project_name)){
                    echo esc_html_e($project->project_name,'taskbuilder');
                    }
                    ?>
                  </td>
                  <td>
                  <?php if(!empty($task->status)){ ?>
                            <span class="wppm_td_task_status" style="background-color:<?php echo (isset($status->bg_color))? esc_attr($status->bg_color):"";?>; color: <?php echo (isset($status->color))? esc_attr($status->color):""; ?>"><?php echo (isset($status->name))? esc_html_e($status->name,'taskbuilder'):"" ?></span>
                  <?php } ?>
                  </td>
                  <td>
                    <?php if(!empty($task->priority)){ ?>
                            <span class ="wppm_td_task_priority" style="background-color:<?php echo (isset($priority->bg_color))? esc_attr($priority->bg_color):"" ;?>; color: <?php echo (isset($priority->color))? esc_attr($priority->color):""; ?>"><?php echo (isset($priority->name))? esc_html_e($priority->name,'taskbuilder'):"" ?></span>
                    <?php } ?>
                  </td>
                  <td>
                  <?php if(!empty($task->start_date)){ ?>
                            <?php echo esc_html_e($task->start_date,'taskbuilder');
                        } ?>
                  </td>
                  <td>
                  <?php if(!empty($task->end_date)){ ?>
                          <?php echo esc_html_e($task->end_date,'taskbuilder');
                        } ?>
                  </td>
                  </td>
                  <td style="text-align:center;">
                    <?php 
                      $project_data = $wppmfunction->get_project($task->project);
                      $i=0;
                      if(!empty($project_data['users'])){
                        $proj_users = explode(',',$project_data['users']);
                      }
                      if(!empty($task->users)){
                        $users = explode(",",$task->users);
                        foreach($users as $user){ 
                          if( (!empty($proj_users)) && (in_array($user,$proj_users))){
                            $i++;
                            if( $i <= 4 ){
                              $userdata = get_userdata( $user ); 
                              if(!empty($userdata)){
                                ?>
                                <a href="#" title="<?php echo esc_attr($userdata->display_name); ?>">
                                  <?php echo get_avatar($userdata->ID, 25, "mysteryman")?>
                                </a> <?php
                              }
                            }
                          }
                        }
                      } 
                      if($i > 4){
                        ?>
                        <a href="#" class="wppm_avatar">
                          <span id="wppm_avatar" style="background-color:black;" class="avatar">+<?php echo esc_html($i-4) ?></span>
                        </a>
                      <?php } ?>
                      <?php
                      if($i==0){
                        echo esc_html_e('None','taskbuilder');
                      } ?>
                  </td>
                  <td>
                    <?php
                    $completion = 0;
                    if ($total != 0 && $total != NULL) {
                      $completion = intval($total_checked_items/$total*100);
                    }
                    echo esc_html($completion).'%';
                    ?>
                </tr>
      <?php   }
          } 
        }
        ?>
      </tbody>
    </table>
    <?php
    $current_page=$page_no+1;
    $total_pages=ceil($totalrows/$task_per_page);
    $prev_page_no=$current_page-1;
    $prev_class=($prev_page_no==0)?'disabled':'';
    $next_page_no=($total_pages==$current_page)? $current_page-1:$current_page;
    $next_class=($total_pages==$current_page)?'disabled':'';
    ?>
    <div class="row" style="background-color:#ffffff;">
      <div class="col-sm-12">
        <div class="wppm_task_result" style="<?php echo esc_attr($total_pages==0)? '':'display: none;';?>"><?php _e('Your search request returned no results.','taskbuilder');?></div>
        <hr style="<?php echo esc_attr($total_pages==0)? '':'display: none;';?>">
      </div>
    <div>
  </div>
</div>
<div class="row wppm_task_pagination_container">
  <div class="col-sm-4">
    <?php echo esc_html_e('Total:','taskbuilder'); ?>&nbsp;<?php echo esc_attr($task_index) ?>&nbsp;<?php echo esc_html_e('of','taskbuilder') ?>&nbsp;<?php echo esc_html($totalrows) ?>&nbsp;<?php echo esc_html_e('Tasks','taskbuilder')?>
  </div>
  <div class="wppm_task_pagination col-sm-4" style="<?php echo esc_attr($total_pages==0)? "display:none;":"display:flex;"?>">
    <span class="wppm-pagination-txt">
        <span><?php echo esc_html($current_page)?>&nbsp;<?php echo esc_html_e('of','taskbuilder');?>&nbsp;<?php echo esc_html($total_pages); ?>&nbsp;<?php echo esc_html_e('Page','taskbuilder'); ?></span>
    </span>
    <span <?php echo esc_attr($prev_class) ?> 
      style="<?php echo (isset($prev_class) && esc_attr($prev_class)== 'disabled') ? 'display:none;':'display:block;'?>cursor:pointer;">
      <a class="wppm_pagination_prev" onclick="return wppm_load_prev_task_page(<?php echo esc_attr($prev_page_no) ?>,<?php echo esc_attr($page_no) ?>);"><?php echo esc_html_e('PREV','taskbuilder');?></a>
    </span>
    <span <?php echo esc_attr($next_class) ?>
      style="<?php echo (isset($next_class) && esc_attr($next_class) == 'disabled')?'display:none;':'display:block;'?>cursor:pointer;">
      <a class="wppm_pagination_next" onclick="return wppm_load_next_task_page(<?php echo esc_attr($next_page_no) ?>,<?php echo esc_attr($page_no) ?>);"><?php echo esc_html_e('NEXT','taskbuilder');?></a>
    </span>
  </div>
</div>
<script type="text/javascript">
  var link = true;
  jQuery( document ).ready( function( jQuery ) {
    jQuery("input[name='wppm_task_search_filter']").keypress(function(e) {
          //Enter key
      if (e.which == 13) {
        wppm_task_search_filter();
      }
    });
  })
</script>

